Program WirujaceKwadraty;

{----------------------------------------------------------}  

Procedure Wczytaj(Var b,alfa: real);

Begin
  Repeat 
    Write('bok='); ReadLn(b) 
  until b>0; 
  Repeat 
    Write('alfa='); ReadLn(alfa)
  until (alfa>0) and (alfa<90)
end; {Wczytaj}

{----------------------------------------------------------}

Procedure Hop(dx,dy: real);

Begin
  PenUp; 
  Forward(dy); Right(90); 
  Forward(dx); Left(90);
  PenDown
end; {Hop}

{----------------------------------------------------------}  

Procedure Kwadrat(a: real); 

Var i: integer; 

Begin
  Hop(-a/2,-a/2);
  For i:=1 to 4 do 
    Begin 
      Forward(a); Right(90) 
    end;
  Hop(a/2,a/2) 
end; {Kwadrat} 

{----------------------------------------------------------}  

Procedure Kwadraty(a,alfa: real); 

Var alfa1,beta: real;
 
Begin  
  alfa1:=alfa*pi/180;
  beta:=Heading;
  While a>10 do 
    Begin 
      Kwadrat(a); 
      Right(alfa);
      a:=a/(sin(alfa1)+cos(alfa1))
    end;
  SetHeading(beta) 
end; {Kwadraty}

{----------------------------------------------------------}

Procedure Mozaika(b,alfa: real);  
 
Var i: integer; 

Begin 
  Clear; Hide;
  PenUp; SetPosition(b/4,b/4); PenDown;
  For i:=0 to 3 do 
    Begin  
      If not odd(i) then Kwadraty(b/2,alfa) 
      else Kwadraty(b/2,90-alfa);
      Hop(b/2,0); Right(90) 
    end;
  Hop(b/4,-b/4) 
end; {Mozaika}

{----------------------------------------------------------}

Var b,alfa: real;

Begin
  Wczytaj(b,alfa);
  Mozaika(b,alfa)
end.
